/*************************************************************************
   Hardware-Definitionen
   Holger Klabunde
   16.11.2001
 ************************************************************************/
#ifndef portio_h
#define portio_h

/* Borland C++ Befehle */
/*
outportb(int adr,unsigned char byte);
inportb(int adr);
*/

/* durch VisualC++ Befehle per Makro ersetzen */
/*
int _outp( unsigned short port, int databyte );
int _inp( unsigned short port );
*/

/* #define outportb(a,b) _outp((unsigned short)(a),(int)(b)); */
/* #define inportb(a) (unsigned char)_inp((unsigned short)(a)); */

/* Linux-spezifische Anpassungen */
#ifdef __linux__
#include <errno.h>
#include <sys/io.h>
#define outportb(addr, data) outb(data, addr)
#define inportb(addr) inb(addr)
#endif

/* Parallelport Steuerport Ausgaenge */
#define STROBE		0x01  /* Invertiert ! */
#define AUTO        0x02  /* CMD0 Invertiert ! */
#define INIT        0x04  /* CMD1 Nicht invertiert */
#define SLCTIN      0x08  /* Invertiert ! */

/* STROBE an-aus. Invertiert ! */
#define STROBE_ON() { steuer&=~STROBE; outportb(control,steuer); }
#define STROBE_OFF()  { steuer|=STROBE;  outportb(control,steuer); }

/* CMD0=0, CMD1=0 */
#define ADR_HI		STROBE+AUTO          /* 0=> A15..8 */
/* CMD0=1, CMD1=0 */
#define ADR_LO		STROBE               /* 1=> A7..0 */
/* CMD0=0, CMD1=1 */
#define DATEN       STROBE+AUTO+INIT     /* 2=> D7..0 */
/* CMD0=1, CMD1=1 */
#define SIMULATOR   STROBE+INIT          /* 3=> Eprom Mode */

#define NO_ERRORS	0
#define NO_PIC		1

#endif /* portio_h */
